//
// TrendView.h : header file
//
// Trend Display ver 1.0
//
// Written by Majid Shahabfar (shahabfar@safineh.net)
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included.
//
// This file is provided with no expressed or implied warranty.
// The author accepts no responsibility if it causes any damage to your
// computer.
//
// Please use and enjoy and let me know of any bugs/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// code. 
//
// An email letting me know how you are using it would be nice as well.
//
/////////////////////////////////////////////////////////////////////////////

#pragma once
#include "afxwin.h"
#include "TrendDoc.h"

// CTrendView form view

class CTrendView : public CFormView
{
	DECLARE_DYNCREATE(CTrendView)

protected:
	CTrendView();           // protected constructor used by dynamic creation
	virtual ~CTrendView();

public:
	enum { IDD = IDD_TRENDVIEW };
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
	virtual void OnDraw(CDC* pDC);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

private:
    LRESULT MyDrawItem(LPDRAWITEMSTRUCT lp);
    void    FillTrendListCtrl();
    void    DrawGridLines(CDC* pDC);
	void    DrawRulers(CDC* pDC,int width);
	void    StartTimer();
	void    StopTimer();
	void    DrawTrend();
	void    DrawScale(CDC* pDC);
	void    DrawTime(CDC*);
	CRect      m_rect;
	CRect      m_trendRect;
	CRect      m_trendWndRect;
	CRect      m_trendListRect;
	CTime      m_initialTime;
	CTime      m_finalTime;
	CTime      m_stepTime[3];
	CTimeSpan  m_tempTime;
	CTrendDoc* m_pDoc;
	CListCtrl* m_pTrendList;
	CPen*      m_OldPen;
    CPen       m_pen;
    CDC*       m_pDC;
	int        m_timeStep;
	int        m_scanTime;
   	float      m_portion;
	float      m_TempValue;

public:
	void     FillList(BYTE index,float value);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual void OnInitialUpdate();
	afx_msg void OnTimer(UINT nIDEvent);
};
